import axios from "axios";

export async function iHeartJaneAuthentication() {
    try {
        const endpoint = process.env.IHEARTJANE_API_HOST;;
        const clientId = process.env.IHEARTJANE_API_CLIENT_ID;
        const clientSecret = process.env.IHEARTJANE_API_CLIENT_SECRET;

        const apiUrl = `${endpoint}/api/oauth/token`;
        const data = {
            grant_type: "client_credentials",
            client_id: clientId,
            client_secret: clientSecret
        };

        const config = {
            headers: {
                "Content-Type": "application/json"
            }
        };

        const response = await axios.post(apiUrl, data, config);
        if (response.status === 200) {
            return response.data;
        }
    } catch (error) {
        console.log(error);
        return error;
    }
}