import { Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards } from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { DiscoverCmsService } from "./discover-cms.service";
import { UpdateDiscoverCmsDto } from "./dto/update-discover-cms.dto";

@Controller({ path: "discover-cms", version: Constants.API_VERSION_1 })

export class DiscoverCmsController {
    constructor(private readonly service: DiscoverCmsService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
      @Body() dto: UpdateDiscoverCmsDto
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    // @UseGuards(AdminAuthGuard)
    findAll() {
        return this.service.findAll();
    }
}
