import { Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards } from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { UpdateHighDealsCmsDto } from "./dto/update-high-deals-cms.dto";
import { HighDealsCmsService } from "./high-deals-cms.service";

@Controller({ path: "high-deals-cms", version: Constants.API_VERSION_1 })

export class HighDealsCmsController {
    constructor(private readonly service: HighDealsCmsService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
      @Body() dto: UpdateHighDealsCmsDto
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    // @UseGuards(AdminAuthGuard)
    findAll() {
        return this.service.findAll();
    }
}
