import { Module } from "@nestjs/common";
import { HomePageMobileCategoryCmsService } from "./home-page-mobile-category-cms.service";
import { HomePageMobileCategoryCmsController } from "./home-page-mobile-category-cms.controller";
import { TypeOrmModule } from "@nestjs/typeorm";
import { HomePageMobileCategoryCmsRepository } from "./home-page-mobile-category-cms.repository";
import { JwtModule } from "@nestjs/jwt";
import JwtConfigService from "src/core/jwt/jwt-config.service";
import JwtHelper from "src/core/jwt/jwt.helper";
import { UsersRepository } from "src/modules/users/user.repository";

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([UsersRepository]),
        TypeOrmModule.forFeature([HomePageMobileCategoryCmsRepository])
    ],
    controllers: [HomePageMobileCategoryCmsController],
    providers: [HomePageMobileCategoryCmsService, JwtHelper]
})
export class HomePageMobileCategoryCmsModule {
}
