import { Body, Controller, Get, HttpCode, HttpStatus, Post, Query, UseGuards } from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { HomePageSectionFourCmsService } from "./home-page-section-four-cms.service";
import { UpdateHomePageSectionFourCmsDto } from "./dto/update-home-page-section-four-cms.dto";

@Controller({ path: "home-page-section-four-cms", version: Constants.API_VERSION_1 })

export class HomePageSectionFourCmsController {
    constructor(private readonly service: HomePageSectionFourCmsService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
        @Body() dto: UpdateHomePageSectionFourCmsDto
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    // @UseGuards(AdminAuthGuard)
    // findAll(@Query("stateCode") stateCode: string) {
    findAll() {
        return this.service.findAll();
    }
}
