import { EntityRepository, Repository } from "typeorm";
import { UpdateHomePageSectionNineCmsDto } from "./dto/update-home-page-section-nine-cms.dto";
import { HomePageSectionNineCms } from "./entities/home-page-section-nine-cms.entity";

@EntityRepository(HomePageSectionNineCms)
export class HomePageSectionNineCmsRepository extends Repository<HomePageSectionNineCms> {

    async createEntity(dto: UpdateHomePageSectionNineCmsDto): Promise<HomePageSectionNineCms | Error> {
        try {
            const entity = this.create({
                // stateCode: dto.stateCode,
                // stateName: dto.stateName,
                titleOne: dto.titleOne,
                titleTwo: dto.titleTwo,
                subTitle: dto.subTitle,
                // isDefault: dto.isDefault
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateHomePageSectionNineCmsDto, id: string): Promise<HomePageSectionNineCms | Error> {
        try {
            await this.update(id, {
                // stateCode: dto.stateCode,
                // stateName: dto.stateName,
                titleOne: dto.titleOne,
                titleTwo: dto.titleTwo,
                subTitle: dto.subTitle,
                // isDefault: dto.isDefault
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<HomePageSectionNineCms[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }

    async findByStateCode(stateCode: string): Promise<any | Error> {
        try {
            let data = await this.find({
                // stateCode: stateCode,
                isDeleted: false
            })
            // if(Object.keys(data).length === 0) {
            //     data = await this.find({
            //         isDefault: true,
            //         isDeleted: false
            //     });
            //     if(Object.keys(data).length === 0) {
            //         data = await this.find({
            //             isDeleted: false
            //         });
            //     }
            // }
            return data;
        } catch (e) {
            return e;
        }
    }
}