import { Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards } from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { pageSchemaDto } from "./dto/page-schema.dto";
import { PageSchemaService } from "./page-schema.service";

@Controller({ path: "page-schema", version: Constants.API_VERSION_1 })
export class PageSchemaController {
    constructor(private readonly service: PageSchemaService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(@Body() dto: pageSchemaDto) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    findAll() {
        return this.service.findAll();
    }
}
