import { Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards } from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { UpdateQuizPageCmsDto } from "./dto/update-quiz-page-cms.dto";
import { QuizPageCmsService } from "./quiz-page-cms.service";

@Controller({ path: "quiz-page-cms", version: Constants.API_VERSION_1 })

export class QuizPageCmsController {
    constructor(private readonly service: QuizPageCmsService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
      @Body() dto: UpdateQuizPageCmsDto
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    // @UseGuards(AdminAuthGuard)
    findAll() {
        return this.service.findAll();
    }
}
