import { Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards } from "@nestjs/common";
import { SectionTwoBottomService } from "./section-two-bottom.service";
import { SectionTwoBottomDto } from "./dto/section-two-bottom.dto";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";

@Controller({ path: "section-two-bottom", version: Constants.API_VERSION_1 })
export class SectionTwoBottomController {
    constructor(private readonly service: SectionTwoBottomService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
      @Body() dto: SectionTwoBottomDto
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    findAll() {
        return this.service.findAll();
    }
}
