import { EntityRepository, Repository } from "typeorm";
import { UpdateArticleDetailsPageUiDto } from "./dto/update-article-details-page-ui.dto";
import { ArticleDetailsPageUI } from "./entities/article-details-page-ui.entity";

@EntityRepository(ArticleDetailsPageUI)
export class ArticleDetailsPageUiRepository extends Repository<ArticleDetailsPageUI> {

    async createEntity(dto: UpdateArticleDetailsPageUiDto): Promise<ArticleDetailsPageUI | Error> {
        try {
            const entity = this.create({
                titleFontColor: dto.titleFontColor,
                subTitleFontColor: dto.subTitleFontColor,
                backgroundColor: dto.backgroundColor
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateArticleDetailsPageUiDto, id: string): Promise<ArticleDetailsPageUI | Error> {
        try {
            await this.update(id, {
                titleFontColor: dto.titleFontColor,
                subTitleFontColor: dto.subTitleFontColor,
                backgroundColor: dto.backgroundColor
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<ArticleDetailsPageUI[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}