import { Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards } from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { LoginPageUiService } from "./login-page-ui.service";
import { UpdateLoginPageUiDto } from "./dto/update-login-page-ui.dto";

@Controller({ path: "login-component-ui", version: Constants.API_VERSION_1 })

export class LoginPageUiController {
    constructor(private readonly service: LoginPageUiService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
      @Body() dto: UpdateLoginPageUiDto
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    // @UseGuards(AdminAuthGuard)
    findAll() {
        return this.service.findAll();
    }
}
