import { EntityRepository, Repository } from "typeorm";
import { UpdateLoginPageUiDto } from "./dto/update-login-page-ui.dto";
import { LoginPageUI } from "./entities/login-page-ui.entity";

@EntityRepository(LoginPageUI)
export class LoginPageUiRepository extends Repository<LoginPageUI> {

    async createEntity(dto: UpdateLoginPageUiDto): Promise<LoginPageUI | Error> {
        try {
            const entity = this.create({
                backgroundColor: dto.backgroundColor,
                titleFontColor: dto.titleFontColor,
                buttonColor: dto.buttonColor,
                buttonFontColor: dto.buttonFontColor,
                bottomOneFontColor: dto.bottomOneFontColor,
                bottomTwoFontColor: dto.bottomTwoFontColor
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateLoginPageUiDto, id: string): Promise<LoginPageUI | Error> {
        try {
            await this.update(id, {
                backgroundColor: dto.backgroundColor,
                titleFontColor: dto.titleFontColor,
                buttonColor: dto.buttonColor,
                buttonFontColor: dto.buttonFontColor,
                bottomOneFontColor: dto.bottomOneFontColor,
                bottomTwoFontColor: dto.bottomTwoFontColor
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<LoginPageUI[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}