import { EntityRepository, Repository } from "typeorm";
import { ProductDetailsPageUI } from "./entities/product-details-page-ui.entity";
import { UpdateProductDetailsPageUiDto } from "./dto/update-product-details-page-ui.dto";

@EntityRepository(ProductDetailsPageUI)
export class ProductDetailsPageUiRepository extends Repository<ProductDetailsPageUI> {

    async createEntity(dto: UpdateProductDetailsPageUiDto): Promise<ProductDetailsPageUI | Error> {
        try {
            const entity = this.create({
                discoverSectionBackgroundColor: dto.discoverSectionBackgroundColor
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateProductDetailsPageUiDto, id: string): Promise<ProductDetailsPageUI | Error> {
        try {
            await this.update(id, {
                discoverSectionBackgroundColor: dto.discoverSectionBackgroundColor
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<ProductDetailsPageUI[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}