import { Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards } from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { UserBannerComponentUiService } from "./user-banner-component-ui.service";
import { UpdateUserBannerComponentUiDto } from "./dto/update-user-banner-component-ui.dto";

@Controller({ path: "user-banner-component-ui", version: Constants.API_VERSION_1 })

export class UserBannerComponentUiController {
    constructor(private readonly service: UserBannerComponentUiService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
      @Body() dto: UpdateUserBannerComponentUiDto
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    // @UseGuards(AdminAuthGuard)
    findAll() {
        return this.service.findAll();
    }
}
