import { Module } from "@nestjs/common";
import { JwtModule } from "@nestjs/jwt";
import { TypeOrmModule } from "@nestjs/typeorm";
import JwtConfigService from "src/core/jwt/jwt-config.service";
import JwtHelper from "src/core/jwt/jwt.helper";
import { UsersRepository } from "src/modules/users/user.repository";
import { ContactReasonController } from "./contact-reason.controller";
import { ContactReasonRepository } from "./contact-reason.repository";
import { ContactReasonService } from "./contact-reason.service";

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([UsersRepository]),
        TypeOrmModule.forFeature([ContactReasonRepository])
    ],
    controllers: [ContactReasonController],
    providers: [ContactReasonService, JwtHelper]
})
export class ContactReasonModule {
}
