import { Controller, Get, Post, Body, Patch, Param, Delete, HttpStatus, HttpCode, Query } from '@nestjs/common';
import { IheartjaneService } from './iheartjane.service';
import { CreateIheartjaneDto } from './dto/create-iheartjane.dto';
import { UpdateIheartjaneDto } from './dto/update-iheartjane.dto';
import { Constants } from 'src/utils/constants';

@Controller({
  path: "iheartjane",
  version: Constants.API_VERSION_1
})
export class IheartjaneController {
  constructor(private readonly iheartjaneService: IheartjaneService) {}

  @Post("/authentication")
  authentication(){
    return this.iheartjaneService.authentication();
  }

  @Get("/all-products")
  allProducts(
    @Query('paginationId') paginationId: number,
    @Query('pageSize') pageSize: number,
  ){
    return this.iheartjaneService.allProducts(paginationId, pageSize);
  }

  @Get("/find-product-slug-or-productid")
  findProductSlugOrProductId(
    @Query('slugOrProductId') slugOrProductId: string,
    @Query('storeIds') storeIds: any,
  ){
    return this.iheartjaneService.findProductSlugOrProductId(slugOrProductId, storeIds);
  }

  @Get("/all-store")
  allStore(){
    return this.iheartjaneService.allStore();
  }

  @Get("/findone-store/:id")
  findOneStore(@Param('id') id: string){
    return this.iheartjaneService.findOneStore(id);
  }

  @Get("/specials/:id")
  allSpecials(@Param('id') id: string){
    return this.iheartjaneService.allSpecials(id);
  }
}
