import { Injectable } from "@nestjs/common";
import { InjectRepository } from "@nestjs/typeorm";
import { ResponseUtils } from "src/utils/response.utils";
import { AboutPageSectionTwoRepository } from "../about-page-section-two/about-page-section-two.repository";
import { CareerRepository } from "../career/career.repository";
import { AboutPageCmsRepository } from "../CMS/about-page-cms/about-page-cms.repository";
import { CareerPageCmsRepository } from "../CMS/career-page-cms/career-page-cms.repository";
import { ContactPageCmsRepository } from "../CMS/contact-page-cms/contact-page-cms.repository";
import { FAQPageCmsRepository } from "../CMS/faq-page-cms/faq-page-cms.repository";
import { FooterCmsRepository } from "../CMS/footer-cms/footer-cms.repository";
import {
    HomePageCommonBannerCmsRepository
} from "../CMS/home-page-common-banner-cms/home-page-common-banner-cms.repository";
import {
    HomePageSectionFourCmsRepository
} from "../CMS/home-page-section-four-cms/home-page-section-four-cms.repository";
import {
    HomePageSectionSevenCmsRepository
} from "../CMS/home-page-section-seven-cms/home-page-section-seven-cms.repository";
import {
    HomePageSectionThreeCmsRepository
} from "../CMS/home-page-section-three-cms/home-page-section-three-cms.repository";
import { HomePageSectionTwoCmsRepository } from "../CMS/home-page-section-two-cms/home-page-section-two-cms.repository";
import { NewDropBannerCmsRepository } from "../CMS/new-drop-banner-cms/new-drop-banner-cms.repository";
import { PressReleaseCmsRepository } from "../CMS/press-release-cms/press-release-cms.repository";
import { FAQRepository } from "../faq/faq.repository";
import { HomePageSectionOneRepository } from "../home-page-section-one/home-page-section-one.repository";
import { SocialPackRepository } from "../social-pack/social-pack.repository";
import { PressReleaseRepository } from "../press-release/press-release.repository";
import { ArticlePageCmsRepository } from "../CMS/article-page-cms/article-page-cms.repository";
import { BlogPostRepository } from "../blog/blog-post/blog-post.repository";
import { FindOperator, In, Like } from "typeorm";
import { BlogCategoryRepository } from "../blog/blog-category/blog-category.repository";
import { BlogTagRepository } from "../blog/blog-tag/blog-tag.repository";
import { CareerDepartmentRepository } from "../career-department/career-department.repository";
import { UpdateBlogPostDto } from "../blog/blog-post/dto/update-blog-post.dto";
import { BlogPostTagsRepository } from "../blog/blog-post-tags/blog-post-tags.repository";
import { BlogRelatedPostsRepository } from "../blog/blog-related-posts/blog-related-posts.repository";
import { QuizRepository } from "../quiz/quiz.repository";
import { QuizPageCmsRepository } from "../CMS/quiz-page-cms/quiz-page-cms.repository";
import { CareerApplicantRepository } from "../career-applicant/career-applicant.repository";
import { ContactMessageRepository } from "../contact-message/contact-message.repository";
import { FeedbackRepository } from "../feedback/feedback.repository";
import { DutchiePlusRetailerService } from "../dutchie-plus/dutchie-plus-retailer/dutchie-plus-retailer.service";
import {
    RetailerServiceRepository
} from "../dutchie-plus/custom-services/retailer-service/retailer-service.repository";
import { PageTitleCmsRepository } from "../CMS/page-title-cms/page-title-cms.repository";
import {
    HomePageSectionEightCmsRepository
} from "../CMS/home-page-section-eight-cms/home-page-section-eight-cms.repository";
import {
    HomePageSectionNineCmsRepository
} from "../CMS/home-page-section-nine-cms/home-page-section-nine-cms.repository";
import {
    HomePageSectionFourSliderRepository
} from "../CMS/home-page-section-four-slider/home-page-section-four-slider.repository";
import {
    HomePageSectionFiveCmsRepository
} from "../CMS/home-page-section-five-cms/home-page-section-five-cms.repository";
import { HomePageSectionFiveRepository } from "../home-page-section-five/home-page-section-five.repository";
import { HomePageSectionTwoRepository } from "../home-page-section-two/home-page-section-two.repository";
import { HomePageNewDropsBannerRepository } from "../home-page-new-drops-banner/home-page-new-drops-banner.repository";
import { HomePageSectionEightRepository } from "../home-page-section-eight/home-page-section-eight.repository";
import { ServiceTypeCmsRepository } from "../CMS/service-type-cms/service-type-cms.repository";
import { HeaderBannerCmsRepository } from "../CMS/header-banner-cms/header-banner-cms.repository";
import { HeaderCmsRepository } from "../CMS/header-cms/header-cms.repository";
import { PageMetaCmsRepository } from "../page-meta-cms/page-meta-cms.repository";
import { AboutPageHeaderCmsRepository } from "../CMS/about-page-header-cms/about-page-header-cms.repository";
import {
    AboutPageSectionOneCmsRepository
} from "../CMS/about-page-section-one-cms/about-page-section-one-cms.repository";
import {
    AboutPageSectionTwoCmsRepository
} from "../CMS/about-page-section-two-cms/about-page-section-two-cms.repository";
import {
    AboutPageSectionThreeCmsRepository
} from "../CMS/about-page-section-three-cms/about-page-section-three-cms.repository";
import {
    TopTickerComponentUiRepository
} from "../component-ui-cms/top-ticker-component-ui/top-ticker-component-ui.repository";
import { HomePageUiRepository } from "../component-ui-cms/home-page-component-ui/home-page-ui.repository";
import { HomePageSubNavRepository } from "../CMS/home-page-sub-nav/home-page-sub-nav.repository";
import { ArticlePageUiRepository } from "../component-ui-cms/article-page-component-ui/article-page-ui.repository";
import { ArticleDetailsPageUiRepository } from "../component-ui-cms/article-details-page-component-ui/article-details-page-ui.repository";
import { PressPageUiRepository } from "../component-ui-cms/press-page-component-ui/press-page-ui.repository";
import { PressDetailsPageUiRepository } from "../component-ui-cms/press-details-page-component-ui/press-details-page-ui.repository";
import { ContactPageUiRepository } from "../component-ui-cms/contact-page-component-ui/contact-page-ui.repository";
import { CareerPageUiRepository } from "../component-ui-cms/career-page-component-ui/career-page-ui.repository";
import { AboutPageUiRepository } from "../component-ui-cms/about-page-component-ui/about-page-ui.repository";
import { TermsConditionPageUiRepository } from "../component-ui-cms/terms-condition-component-ui/terms-condition-page-ui.repository";
import { PrivacyPolicyPageUiRepository } from "../component-ui-cms/privacy-policy-component-ui/privacy-policy-page-ui.repository";
import { CookiesSettingsPageUiRepository } from "../component-ui-cms/cookies-settings-component-ui/cookies-settings-page-ui.repository";
import { FaqPageUiRepository } from "../component-ui-cms/faq-page-component-ui/career-page-ui.repository";
import { LandingPageUiRepository } from "../component-ui-cms/landing-page-component-ui/landing-page-ui.repository";
import { JarsPlusPageUiRepository } from "../component-ui-cms/jars-plus-page-component-ui/jars-plus-page-ui.repository";
import { CartCounterCmsRepository } from "../CMS/cart-counter-cms/cart-counter-cms.repository";
import { HomePageMobileCategoryCmsRepository } from "../CMS/home-page-mobile-category-cms/home-page-mobile-category-cms.repository";
import { LoginPageCmsRepository } from "../CMS/login-page-cms/login-page-cms.repository";
import { RegisterPageCmsRepository } from "../CMS/register-page-cms/register-page-cms.repository";
import { LoginPageUiRepository } from "../component-ui-cms/login-page-component-ui/login-page-ui.repository";
import { RegisterPageUiRepository } from "../component-ui-cms/register-page-component-ui/register-page-ui.repository";
import { ShopPageBannerCmsRepository } from "../CMS/shop-page-banner-cms/shop-page-banner-cms.repository";
import { ShopBannerComponentUiRepository } from "../component-ui-cms/shop-banner-component-ui/shop-banner-component-ui.repository";

@Injectable()
export class SiteFrontendService {
    constructor(
        @InjectRepository(AboutPageCmsRepository)
        private readonly aboutPageCmsRepository: AboutPageCmsRepository,
        @InjectRepository(AboutPageSectionTwoRepository)
        private readonly aboutPageSectionTwoRepository: AboutPageSectionTwoRepository,
        @InjectRepository(HomePageCommonBannerCmsRepository)
        private readonly homePageCommonBannerCmsRepository: HomePageCommonBannerCmsRepository,
        @InjectRepository(NewDropBannerCmsRepository)
        private readonly newDropBannerCmsRepository: NewDropBannerCmsRepository,
        @InjectRepository(HomePageSectionThreeCmsRepository)
        private readonly homePageSectionThreeCmsRepository: HomePageSectionThreeCmsRepository,
        @InjectRepository(ContactPageCmsRepository)
        private readonly contactPageCmsRepository: ContactPageCmsRepository,
        @InjectRepository(FAQPageCmsRepository)
        private readonly faqPageCmsRepository: FAQPageCmsRepository,
        @InjectRepository(FAQRepository)
        private readonly faqRepository: FAQRepository,
        @InjectRepository(SocialPackRepository)
        private readonly socialPackRepository: SocialPackRepository,
        @InjectRepository(FooterCmsRepository)
        private readonly footerCmsRepository: FooterCmsRepository,
        @InjectRepository(CareerPageCmsRepository)
        private readonly careerPageCmsRepository: CareerPageCmsRepository,
        @InjectRepository(CareerRepository)
        private readonly careerRepository: CareerRepository,
        @InjectRepository(HomePageSectionOneRepository)
        private readonly homePageSectionOneRepository: HomePageSectionOneRepository,
        @InjectRepository(HomePageSectionTwoCmsRepository)
        private readonly homePageSectionTwoCmsRepository: HomePageSectionTwoCmsRepository,
        @InjectRepository(HomePageSectionFourCmsRepository)
        private readonly homePageSectionFourCmsRepository: HomePageSectionFourCmsRepository,
        @InjectRepository(HomePageSectionSevenCmsRepository)
        private readonly homePageSectionSevenCmsRepository: HomePageSectionSevenCmsRepository,
        @InjectRepository(PressReleaseCmsRepository)
        private readonly pressReleaseCmsRepository: PressReleaseCmsRepository,
        @InjectRepository(PressReleaseRepository)
        private readonly pressReleaseRepository: PressReleaseRepository,
        @InjectRepository(ArticlePageCmsRepository)
        private readonly articlePageCmsRepository: ArticlePageCmsRepository,
        @InjectRepository(BlogPostRepository)
        private readonly blogPostRepository: BlogPostRepository,
        @InjectRepository(BlogCategoryRepository)
        private readonly blogCategoryRepository: BlogCategoryRepository,
        @InjectRepository(BlogTagRepository)
        private readonly blogTagRepository: BlogTagRepository,
        @InjectRepository(CareerDepartmentRepository)
        private readonly careerDepartmentRepository: CareerDepartmentRepository,
        @InjectRepository(BlogPostTagsRepository)
        private readonly blogPostTagsRepository: BlogPostTagsRepository,
        @InjectRepository(BlogRelatedPostsRepository)
        private readonly blogRelatedPostsRepository: BlogRelatedPostsRepository,
        @InjectRepository(QuizRepository)
        private readonly quizRepository: QuizRepository,
        @InjectRepository(QuizPageCmsRepository)
        private readonly quizPageCmsRepository: QuizPageCmsRepository,
        @InjectRepository(CareerApplicantRepository)
        private readonly careerApplicantRepository: CareerApplicantRepository,
        @InjectRepository(ContactMessageRepository)
        private readonly contactMessageRepository: ContactMessageRepository,
        @InjectRepository(FeedbackRepository)
        private readonly feedbackRepository: FeedbackRepository,
        private readonly retailerService: DutchiePlusRetailerService,
        @InjectRepository(RetailerServiceRepository)
        private readonly retailerServiceRepo: RetailerServiceRepository,
        @InjectRepository(PageTitleCmsRepository)
        private readonly pageTitleCMSRepo: PageTitleCmsRepository,
        @InjectRepository(HomePageSectionEightCmsRepository)
        private readonly homePageSectionEightCmsRepo: HomePageSectionEightCmsRepository,
        @InjectRepository(HomePageSectionNineCmsRepository)
        private readonly homePageSectionNineCmsRepo: HomePageSectionNineCmsRepository,
        @InjectRepository(HomePageSectionFourSliderRepository)
        private readonly homePageSectionFourSliderRepo: HomePageSectionFourSliderRepository,
        @InjectRepository(HomePageSectionFiveCmsRepository)
        private readonly homePageSectionFiveCmsRepo: HomePageSectionFiveCmsRepository,
        @InjectRepository(HomePageSectionFiveRepository)
        private readonly homePageSectionFiveRepo: HomePageSectionFiveRepository,
        @InjectRepository(HomePageSectionTwoRepository)
        private readonly homePageSectionTwoRepo: HomePageSectionTwoRepository,
        @InjectRepository(HomePageNewDropsBannerRepository)
        private readonly homePageNewDropBannerRepo: HomePageNewDropsBannerRepository,
        @InjectRepository(HomePageSectionEightRepository)
        private readonly homePageSectionEightRepo: HomePageSectionEightRepository,
        @InjectRepository(HeaderCmsRepository)
        private readonly headerCmsRepository: HeaderCmsRepository,
        @InjectRepository(HeaderBannerCmsRepository)
        private readonly headerBannerCmsRepository: HeaderBannerCmsRepository,
        @InjectRepository(ServiceTypeCmsRepository)
        private readonly serviceTypeCmsRepository: ServiceTypeCmsRepository,
        @InjectRepository(PageMetaCmsRepository)
        private readonly pageMetaCmsRepository: PageMetaCmsRepository,
        @InjectRepository(AboutPageHeaderCmsRepository)
        private readonly aboutPageHeaderCmsRepo: AboutPageHeaderCmsRepository,
        @InjectRepository(AboutPageSectionOneCmsRepository)
        private readonly aboutPageSectionOneCmsRepo: AboutPageSectionOneCmsRepository,
        @InjectRepository(AboutPageSectionTwoCmsRepository)
        private readonly aboutPageSectionTwoCmsRepo: AboutPageSectionTwoCmsRepository,
        @InjectRepository(AboutPageSectionThreeCmsRepository)
        private readonly aboutPageSectionThreeCmsRepo: AboutPageSectionThreeCmsRepository,
        @InjectRepository(TopTickerComponentUiRepository)
        private readonly topTickerComponentUiRepo: TopTickerComponentUiRepository,
        @InjectRepository(HomePageUiRepository)
        private readonly homePageUiRepository: HomePageUiRepository,
        @InjectRepository(HomePageSubNavRepository)
        private readonly homePageSubNavRepo: HomePageSubNavRepository,
        @InjectRepository(ArticlePageUiRepository)
        private readonly articleComponentUIRepo: ArticlePageUiRepository,
        @InjectRepository(ArticleDetailsPageUiRepository)
        private readonly articleDetailsComponentUIRepo: ArticleDetailsPageUiRepository,
        @InjectRepository(PressPageUiRepository)
        private readonly pressComponentUIRepo: PressPageUiRepository,
        @InjectRepository(PressDetailsPageUiRepository)
        private readonly pressDetailsComponentUIRepo: PressDetailsPageUiRepository,
        @InjectRepository(ContactPageUiRepository)
        private readonly contactComponentUIRepo: ContactPageUiRepository,
        @InjectRepository(CareerPageUiRepository)
        private readonly careerComponentUIRepo: CareerPageUiRepository,
        @InjectRepository(AboutPageUiRepository)
        private readonly aboutComponentUIRepo: AboutPageUiRepository,
        @InjectRepository(TermsConditionPageUiRepository)
        private readonly termsComponentUIRepo: TermsConditionPageUiRepository,
        @InjectRepository(PrivacyPolicyPageUiRepository)
        private readonly privacyComponentUIRepo: PrivacyPolicyPageUiRepository,
        @InjectRepository(CookiesSettingsPageUiRepository)
        private readonly cookieComponentUIRepo: CookiesSettingsPageUiRepository,
        @InjectRepository(FaqPageUiRepository)
        private readonly faqComponentUIRepo: FaqPageUiRepository,
        @InjectRepository(LandingPageUiRepository)
        private readonly landingComponentUIRepo: LandingPageUiRepository,
        @InjectRepository(JarsPlusPageUiRepository)
        private readonly jarsPlusComponentUIRepo: JarsPlusPageUiRepository,
        @InjectRepository(CartCounterCmsRepository)
        private readonly cartCounterCmsRepo: CartCounterCmsRepository,
        @InjectRepository(HomePageMobileCategoryCmsRepository)
        private readonly homePageMobileCategoryCmsRepo: HomePageMobileCategoryCmsRepository,
        @InjectRepository(LoginPageCmsRepository)
        private readonly loginPageCmsRepo: LoginPageCmsRepository,
        @InjectRepository(RegisterPageCmsRepository)
        private readonly registerPageCmsRepo: RegisterPageCmsRepository,
        @InjectRepository(LoginPageUiRepository)
        private readonly loginPageUiRepo: LoginPageUiRepository,
        @InjectRepository(RegisterPageUiRepository)
        private readonly registerPageUiRepo: RegisterPageUiRepository,
        @InjectRepository(ShopPageBannerCmsRepository)
        private readonly shopPageBannerCmsRepo: ShopPageBannerCmsRepository,
        @InjectRepository(ShopBannerComponentUiRepository)
        private readonly shopBannerComponentUiRepo: ShopBannerComponentUiRepository
    ) {
    }

    async getAboutPageData(): Promise<any | Error> {
        const cmsData = await this.aboutPageCmsRepository.findAll();
        const sectionTwoData = await this.aboutPageSectionTwoRepository.findByFilterQuery({});
        const commonBannerCmsData = await this.homePageCommonBannerCmsRepository.findAll();
        const dropBannerCmsData = await this.newDropBannerCmsRepository.findAll();
        const homeSectionThreeCmsData = await this.homePageSectionThreeCmsRepository.findAll();
        const socialPackData = await this.socialPackRepository.findByFilterQuery({});

        const aboutPageHeaderCmsData = await this.aboutPageHeaderCmsRepo.findAll();
        const aboutPageSectionOneCmsData = await this.aboutPageSectionOneCmsRepo.findAll();
        const aboutPageSectionTwoCmsData = await this.aboutPageSectionTwoCmsRepo.findAll();
        const aboutPageSectionThreeCmsData = await this.aboutPageSectionThreeCmsRepo.findAll();

        const response = {
            cmsData: cmsData,
            sectionTwoData: sectionTwoData,
            commonBannerCmsData: commonBannerCmsData,
            dropBannerCmsData: dropBannerCmsData,
            homeSectionThreeCmsData: homeSectionThreeCmsData,
            socialPackData: socialPackData,
            aboutPageHeaderCmsData,
            aboutPageSectionOneCmsData,
            aboutPageSectionTwoCmsData,
            aboutPageSectionThreeCmsData
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
    }

    async getContactPageData(storeId: string): Promise<any | Error> {
        let cmsData = await this.contactPageCmsRepository.find({
            storeId: storeId,
            isDeleted: false
        });
        if (Object.keys(cmsData).length === 0) {
            cmsData = await this.contactPageCmsRepository.find({
                isDefault: true,
                isDeleted: false
            });
        }
        const commonBannerCmsData = await this.homePageCommonBannerCmsRepository.findAll();
        const socialPackData = await this.socialPackRepository.findByFilterQuery({});

        const response = {
            cmsData: cmsData,
            commonBannerCmsData: commonBannerCmsData,
            socialPackData: socialPackData
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
    }

    async getFaqPageData(): Promise<any | Error> {
        const cmsData = await this.faqPageCmsRepository.findAll();
        const faqData = await this.faqRepository.findByFilterQuery({});
        const commonBannerCmsData = await this.homePageCommonBannerCmsRepository.findAll();

        const response = {
            cmsData: cmsData,
            faqData: faqData,
            commonBannerCmsData: commonBannerCmsData
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
    }

    async getQuizPageData(): Promise<any | Error> {
        const cmsData = await this.quizPageCmsRepository.findAll();
        const quizData = await this.quizRepository.findByFilterQuery({});

        const response = {
            cmsData: cmsData,
            quizData: quizData
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
    }

    async getHeaderFooterData(): Promise<any | Error> {
        const cmsData = await this.footerCmsRepository.findAll();
        const socialPackData = await this.socialPackRepository.findByFilterQuery({});
        const headerCmsData = await this.headerCmsRepository.findAll();
        const headerBannerCmsData = await this.headerBannerCmsRepository.findAll();
        const serviceTypeCmsData = await this.serviceTypeCmsRepository.findAll();

        const response = {
            cmsData: cmsData,
            socialPackData: socialPackData,
            headerCmsData: headerCmsData,
            headerBannerCmsData: headerBannerCmsData,
            serviceTypeCmsData: serviceTypeCmsData
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
    }

    async getHomePageData(stateCode: string): Promise<any | Error> {
        const homeComponentUI = await this.homePageUiRepository.findAll();
        const sliderData = await this.homePageSectionOneRepository.findByStateCode(stateCode);
        const commonBannerCmsData = await this.homePageCommonBannerCmsRepository.findByStateCode(stateCode);
        const sectionTwoCmsData = await this.homePageSectionTwoCmsRepository.findByStateCode(stateCode);
        const sectionThreeCmsData = await this.homePageSectionThreeCmsRepository.findByStateCode(stateCode);
        const sectionFourCmsData = await this.homePageSectionFourCmsRepository.findByStateCode(stateCode);
        const sectionSevenCmsData = await this.homePageSectionSevenCmsRepository.findByStateCode(stateCode);
        const dropBannerCmsData = await this.newDropBannerCmsRepository.findByStateCode(stateCode);
        const homePageSectionEightCmsData = await this.homePageSectionEightCmsRepo.findByStateCode(stateCode);
        const homePageSectionNineCmsData = await this.homePageSectionNineCmsRepo.findByStateCode(stateCode);
        const homePageSectionFourSliderData = await this.homePageSectionFourSliderRepo.findByStateCode(stateCode);
        const homePageSectionFiveCmsData = await this.homePageSectionFiveCmsRepo.findByStateCode(stateCode);
        const homePageSectionFiveData = await this.homePageSectionFiveRepo.findByStateCode(stateCode);
        const homePageSectionTwoData = await this.homePageSectionTwoRepo.findByStateCode(stateCode);
        const homePageNewDropBannerData = await this.homePageNewDropBannerRepo.findByStateCode(stateCode);
        const homePageSectionEightData = await this.homePageSectionEightRepo.findByStateCode(stateCode);
        const homePageSubNav = await this.homePageSubNavRepo.findAll();


        const response = {
            homeComponentUI: homeComponentUI,
            sliderData: sliderData,
            commonBannerCmsData: commonBannerCmsData,
            sectionTwoCmsData: sectionTwoCmsData,
            sectionThreeCmsData: sectionThreeCmsData,
            sectionFourCmsData: sectionFourCmsData,
            sectionSevenCmsData: sectionSevenCmsData,
            dropBannerCmsData: dropBannerCmsData,
            homePageSectionEightCmsData,
            homePageSectionNineCmsData,
            homePageSectionFourSliderData,
            homePageSectionFiveCmsData,
            homePageSectionFiveData,
            homePageSectionTwoData,
            homePageNewDropBannerData,
            homePageSectionEightData,
            homePageSubNav
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
    }

    async getPressReleaseData(): Promise<any | Error> {
        const cmsData = await this.pressReleaseCmsRepository.findAll();
        const pressReleaseData = await this.pressReleaseRepository.findByFilterQuery({});

        const response = {
            cmsData: cmsData,
            pressReleaseData: pressReleaseData
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", response);
    }

    async getPressReleaseDetailsData(urlSlug: string): Promise<any | Error> {
        const cmsData = await this.pressReleaseCmsRepository.findAll();
        const pressReleaseData = await this.pressReleaseRepository.findOneEntityBySlug(urlSlug);

        let data = {
            cmsData: cmsData,
            pressReleaseData: pressReleaseData
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", data);
    }

    async getArticleData(
        page: number,
        limit: number,
        keyword: any,
        tagName: any,
        categoryId: any
    ): Promise<any | Error> {
        type FindOption = {
            title?: FindOperator<string>;
            categoryId?: FindOperator<string>;
        };

        const findOptions: FindOption = {};

        if (keyword) findOptions.title = Like("%" + keyword + "%");
        if (categoryId) findOptions.categoryId = categoryId;

        if (tagName) {
            const cmsData = await this.articlePageCmsRepository.findAll();
            const articleCategoryList = await this.blogCategoryRepository.findByFilterQuery({});
            const articleTagList = await this.blogTagRepository.findByFilterQuery({});
            const topArticleList = await this.blogPostRepository.getTopBlogList();
            const totalArticleCount = await this.blogPostRepository.countAllArticles();
            const articleList = await this.blogPostRepository.findBlogByTagName(
                page,
                limit,
                tagName
            );

            let data = {
                cmsData: cmsData,
                articleCategoryList: articleCategoryList,
                articleTagList: articleTagList,
                topArticleList: topArticleList,
                articleList: articleList,
                totalArticleCount: totalArticleCount
            };

            return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", data);
        } else {
            const cmsData = await this.articlePageCmsRepository.findAll();
            const articleCategoryList = await this.blogCategoryRepository.findByFilterQuery({});
            const articleTagList = await this.blogTagRepository.findByFilterQuery({});
            const topArticleList = await this.blogPostRepository.getTopBlogList();
            const totalArticleCount = await this.blogPostRepository.countAllArticles();
            const articleList = await this.blogPostRepository.findBlogByFilterQuery(
                page,
                limit,
                findOptions
            );

            let data = {
                cmsData: cmsData,
                articleCategoryList: articleCategoryList,
                articleTagList: articleTagList,
                topArticleList: topArticleList,
                articleList: articleList,
                totalArticleCount: totalArticleCount
            };

            return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", data);
        }
    }

    async getArticleDetailsData(urlSlug: string): Promise<any | Error> {
        const cmsData = await this.articlePageCmsRepository.findAll();
        const articleData = await this.blogPostRepository.findOneEntityBySlug(urlSlug);
        let id: any;
        if (Object.keys(articleData).length > 0) {
            id = articleData[0].id;
            let viewCount = 0;
            let totalViews = articleData[0].totalViews;
            let postId = articleData[0].id;
            viewCount = totalViews + 1;
            let blogPostDto = {
                totalViews: viewCount
            };
            await this.blogPostRepository.updateBlogViewCount(
                postId,
                blogPostDto as UpdateBlogPostDto
            );
        }
        const blogTags = await this.blogPostTagsRepository.findBlogPostTagsByPostId(id);
        if (blogTags) {
            articleData[0]["tags"] = blogTags;
        }
        const relatedPosts = await this.blogRelatedPostsRepository.findBlogRelatedPostsByPostId(id);
        let relatedPostsDetails: any = [];
        if (relatedPosts) {
            for (const index in relatedPosts) {
                let postId = `${relatedPosts[index].relatedPostId}`;
                let postData = await this.blogPostRepository.findOneEntity(postId);
                relatedPostsDetails.push(postData[0]);
            }
        }
        articleData[0]["relatedPosts"] = relatedPosts;
        articleData[0]["relatedPostsDetails"] = relatedPostsDetails;

        let data = {
            cmsData: cmsData,
            articleData: articleData
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", data);
    }

    async getCareerPageData(): Promise<any | Error> {
        const cmsData = await this.careerPageCmsRepository.findAll();
        const careerDepartmentList = await this.careerDepartmentRepository.findByFilterQuery({});
        const totalCount = await this.careerRepository.totalCareerCount();
        let careerDepartmentData: any = [];
        for (let i = 0; i < Object.keys(careerDepartmentList).length; i++) {
            const careerCount = await this.careerRepository.countByDepartmentName(careerDepartmentList[i].name);
            careerDepartmentList[i]["count"] = careerCount;
            careerDepartmentData.push(careerDepartmentList[i]);
        }

        const response = {
            cmsData: cmsData,
            careerDepartmentData: careerDepartmentData,
            totalCount: totalCount
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
    }

    async getCareerDetailsData(id: string): Promise<any | Error> {
        const cmsData = await this.careerPageCmsRepository.findAll();
        const careerDetailsData = await this.careerRepository.findByFilterQuery({ id: id });

        const response = {
            cmsData: cmsData,
            careerDetailsData: careerDetailsData
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", response);
    }

    async getCareerDepartmentWiseData(
        departmentName: any
    ): Promise<any | Error> {
        type FindOption = {
            departmentName?: FindOperator<string>;
        };

        const findOptions: FindOption = {};

        if (departmentName) findOptions.departmentName = departmentName;

        const cmsData = await this.careerPageCmsRepository.findAll();
        const careerList = await this.careerRepository.findByFilterQuery(findOptions);
        const isCareerDepartmentExist = await this.careerDepartmentRepository.findOne({
            where: {
                name: departmentName,
                isDeleted: false
            }
        });

        let data = {
            cmsData: cmsData,
            careerList: careerList,
            isCareerDepartmentExist: typeof isCareerDepartmentExist !== "undefined"
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", data);
    }

    async getDiscoverHoverMenuData(): Promise<any | Error> {
        const articleData = await this.blogPostRepository.getTopBlogList();
        const pressReleaseData = await this.pressReleaseRepository.findLatestPressRelease();

        const response = {
            articleData: articleData,
            pressReleaseData: pressReleaseData
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", response);
    }

    async getDashboardData(): Promise<any | Error> {
        const totalCareerApplicant = await this.careerApplicantRepository.countAllQuery();
        const totalContact = await this.contactMessageRepository.countAllQuery();
        const totalPressRelease = await this.pressReleaseRepository.countAllQuery();
        const totalArticle = await this.blogPostRepository.countAllArticles();
        const totalCareer = await this.careerRepository.totalCareerCount();
        const totalFeedback = await this.feedbackRepository.countAllQuery();
        const totalRetailer = await this.retailerService.countAllRetailer();
        const topFiveRetailers = await this.retailerServiceRepo.topFiveRetailerEntity();
        let retailerLevel = [];
        let retailerAccessCount = [];
        for (let i = 0; i < Object.keys(topFiveRetailers).length; i++) {
            retailerLevel.push(topFiveRetailers[i].retailerName);
            retailerAccessCount.push(topFiveRetailers[i].accessCount);
        }
        const topFiveRetailerData = {
            labels: retailerLevel,
            data: retailerAccessCount
        };

        const response = {
            totalCareerApplicant: totalCareerApplicant,
            totalCareer: totalCareer,
            totalContact: totalContact,
            totalPressRelease: totalPressRelease,
            totalArticle: totalArticle,
            totalFeedback: totalFeedback,
            totalRetailer: totalRetailer,
            topFiveRetailer: topFiveRetailerData
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", response);
    }

    async commonCMS(): Promise<any | Error> {
        const pageTitleCMS = await this.pageTitleCMSRepo.findAll();
        const pageMetaCMS = await this.pageMetaCmsRepository.findAll();
        const cmsData = await this.footerCmsRepository.findAll();
        const socialPackData = await this.socialPackRepository.findByFilterQuery({});
        const headerCmsData = await this.headerCmsRepository.findAll();
        const headerBannerCmsData = await this.headerBannerCmsRepository.findAll();
        const serviceTypeCmsData = await this.serviceTypeCmsRepository.findAll();
        const commonBannerCmsData = await this.homePageCommonBannerCmsRepository.findAll();
        const topTicker = await this.topTickerComponentUiRepo.findAll();
        const cartCounter = await this.cartCounterCmsRepo.findAll();
        const homePageMobileCategory = await this.homePageMobileCategoryCmsRepo.findAll();
        const loginPageCms = await this.loginPageCmsRepo.findAll();
        const registerPageCms = await this.registerPageCmsRepo.findAll();
        const shopPageBannerCmsRepo = await this.shopPageBannerCmsRepo.findAll();

        // componentUI
        const articleComponentUI = await this.articleComponentUIRepo.findAll()
        const articleDetailsComponentUI = await this.articleDetailsComponentUIRepo.findAll()
        const pressComponentUI = await this.pressComponentUIRepo.findAll()
        const pressDetailsComponentUI = await this.pressDetailsComponentUIRepo.findAll()
        const contactComponentUI = await this.contactComponentUIRepo.findAll()
        const careerComponentUI = await this.careerComponentUIRepo.findAll()
        const aboutComponentUI = await this.aboutComponentUIRepo.findAll()
        const termsComponentUI = await this.termsComponentUIRepo.findAll()
        const privacyComponentUI = await this.privacyComponentUIRepo.findAll()
        const cookieComponentUI = await this.cookieComponentUIRepo.findAll()
        const faqComponentUI = await this.faqComponentUIRepo.findAll()
        const landingComponentUI = await this.landingComponentUIRepo.findAll()
        const jarsPlusComponentUI = await this.jarsPlusComponentUIRepo.findAll()
        const loginPageComponentUI = await this.loginPageUiRepo.findAll()
        const registerPageComponentUI = await this.registerPageUiRepo.findAll()
        const shopBannerComponentUiRepo = await this.shopBannerComponentUiRepo.findAll()

        const response = {
            pageTitleCMS: pageTitleCMS,
            pageMetaCMS: pageMetaCMS,
            cmsData: cmsData,
            socialPackData: socialPackData,
            headerCmsData: headerCmsData,
            headerBannerCmsData: headerBannerCmsData,
            serviceTypeCmsData: serviceTypeCmsData,
            commonBannerCmsData: commonBannerCmsData,
            topTicker: topTicker,
            cartCounter: cartCounter,
            homePageMobileCategory: homePageMobileCategory,
            loginPageCms: loginPageCms,
            registerPageCms: registerPageCms,
            shopPageBannerCmsRepo: shopPageBannerCmsRepo,
            componentUI: {
                articleComponentUI,
                articleDetailsComponentUI,
                pressComponentUI,
                pressDetailsComponentUI,
                contactComponentUI,
                careerComponentUI,
                aboutComponentUI,
                termsComponentUI,
                privacyComponentUI,
                cookieComponentUI,
                faqComponentUI,
                landingComponentUI,
                jarsPlusComponentUI,
                loginPageComponentUI,
                registerPageComponentUI,
                shopBannerComponentUiRepo,
            }
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", response);
    }
}
